package exlabel.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.BoxLayout;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.ToolTipManager;

import exlabel.structure.ExGraph;
import java.awt.Panel;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public class ExGui extends JApplet implements Runnable
{

	// private ExPaintPanel PaintPane = null;

	/**
	 * 
	 */
	private static final long serialVersionUID = 1552731844261482973L;

	public String currentNodeLabel = ExGraph.STANDARD_NODE_LABEL;

	public String currentEdgeLabel = ExGraph.STANDARD_EDGE_LABEL;

	static int dimx = 800;

	static int dimy = 800;

	long start = 0;

	long tick_end_time;

	long tick_duration;

	long sleep_duration;

	float fps = 0;

	static final int MIN_SLEEP_TIME = 5;

	static final int MAX_FPS = 10000;

	static final int MAX_MS_PER_FRAME = 1000 / MAX_FPS;

	Thread animator;

	private ExGraph graph;

	private JPanel ContentPane = null;

	private ExPaintPanel PaintPanel = null;

	private JPanel RightPanel = null;

	private JPanel upperToolbar = null;

	private JPanel MiddleToolbar = null;

	private JPanel lowerToolbar = null;

	private JButton EditButton = null;

	private JButton createButton = null;

	private JPanel LabelTitlePanel = null;

	private JTextField NodeLabelTitleTextfield = null;

	private JLabel NodelLabelTitleLabel = null;

	private JPanel LowestToolbar = null;

	private JPanel jPanel1 = null;

	private JLabel jLabel = null;

	private JTextField jTextField1 = null;

	private JPanel jPanel = null;

	private JLabel jLabel2 = null;

	private JPanel jPanel3 = null;

	private JLabel jLabel3 = null;

	private JSlider jSlider1 = null;

	private JCheckBox AlphaCheckbox = null;

	private JPanel jPanel4 = null;

	private JLabel jLabel4 = null;

	private JSlider jSlider2 = null;

	private Panel panel = null;

	private JPanel jPanel2 = null;

	private JPanel jPanel5 = null;

	private JLabel jLabel1 = null;

	private JSlider jSlider = null;

	private JPanel jPanel6 = null;

	private JLabel jLabel5 = null;

	private JCheckBox jCheckBox = null;

	private JPanel upPaintPanel = null;

	/**
	 * This is the default constructor
	 */
	public ExGui()
	{
		super();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public void init()
	{
		this.setSize(800, 491);
		this.setMinimumSize(new java.awt.Dimension(800, 600));
		this.setContentPane(getJContentPane());
		ToolTipManager.sharedInstance().setDismissDelay(1000);
		ToolTipManager.sharedInstance().setInitialDelay(10);
		ToolTipManager.sharedInstance().setReshowDelay(10);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane()
	{
		if (ContentPane == null)
		{
			ContentPane = new JPanel();
			ContentPane.setLayout(new BoxLayout(getJContentPane(),
					BoxLayout.X_AXIS));
			ContentPane.setPreferredSize(new java.awt.Dimension(800, 600));
			ContentPane.setBackground(java.awt.Color.white);
			ContentPane.add(getUpPaintPanel(), null);
			ContentPane.add(getRightPanel(), null);
		}
		return ContentPane;
	}

	/**
	 * This method initializes LeftPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private ExPaintPanel getLeftPanel()
	{
		if (PaintPanel == null)
		{
			graph = new ExGraph("test.txt", dimx, dimy);
			// graph.start();
			PaintPanel = new ExPaintPanel(graph, this);
			PaintPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(
					javax.swing.BorderFactory.createLineBorder(
							java.awt.Color.gray, 1), "Graph",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null,
					null));
			PaintPanel.setPreferredSize(new java.awt.Dimension(2000, 2000));
		}
		return PaintPanel;
	}

	/**
	 * This method initializes RightPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getRightPanel()
	{
		if (RightPanel == null)
		{

			GridLayout gridLayout5 = new GridLayout();
			gridLayout5.setRows(1);
			RightPanel = new JPanel();
			RightPanel.setLayout(gridLayout5);
			RightPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(0,
					5, 0, 5));
			RightPanel.setPreferredSize(new java.awt.Dimension(300, 300));
			RightPanel.add(getPanel(), null);
		}
		return RightPanel;
	}

	/**
	 * This method initializes upperToolbar
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getUpperToolbar()
	{
		if (upperToolbar == null)
		{
			GridLayout gridLayout1 = new GridLayout();
			gridLayout1.setRows(2);
			upperToolbar = new JPanel();
			upperToolbar.setPreferredSize(new java.awt.Dimension(200,78));
			upperToolbar.setLayout(gridLayout1);
			upperToolbar
					.setBorder(javax.swing.BorderFactory
							.createTitledBorder(
									javax.swing.BorderFactory.createLineBorder(
											java.awt.Color.gray, 1),
									"Mode",
									javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
									javax.swing.border.TitledBorder.DEFAULT_POSITION,
									null, null));
			upperToolbar.add(getEditButton(), null);
			upperToolbar.add(getCreateButton(), null);
		}
		return upperToolbar;
	}

	/**
	 * This method initializes MiddleToolbar
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getMiddleToolbar()
	{
		if (MiddleToolbar == null)
		{
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(5);
			MiddleToolbar = new JPanel();
			MiddleToolbar.setPreferredSize(new java.awt.Dimension(200,181));
			MiddleToolbar.setLayout(gridLayout);
			MiddleToolbar
					.setBorder(javax.swing.BorderFactory
							.createTitledBorder(
									javax.swing.BorderFactory.createLineBorder(
											java.awt.Color.gray, 1),
									"Parameter",
									javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
									javax.swing.border.TitledBorder.DEFAULT_POSITION,
									null, null));
			MiddleToolbar.add(getJPanel6(), null);
			MiddleToolbar.add(getJPanel3(), null);
			MiddleToolbar.add(getJPanel4(), null);
			MiddleToolbar.add(getJPanel32(), null);
			MiddleToolbar.add(getJPanel5(), null);
		}
		return MiddleToolbar;
	}

	/**
	 * This method initializes lowerToolbar
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getLowerToolbar()
	{
		if (lowerToolbar == null)
		{
			GridLayout gridLayout2 = new GridLayout();
			gridLayout2.setRows(1);
			gridLayout2.setVgap(5);
			lowerToolbar = new JPanel();
			lowerToolbar.setPreferredSize(new java.awt.Dimension(200,56));
			lowerToolbar.setLayout(gridLayout2);
			lowerToolbar
					.setBorder(javax.swing.BorderFactory
							.createTitledBorder(
									javax.swing.BorderFactory.createLineBorder(
											java.awt.Color.gray, 1),
									"Node Info",
									javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
									javax.swing.border.TitledBorder.DEFAULT_POSITION,
									new java.awt.Font("Dialog",
											java.awt.Font.BOLD, 12),
									new java.awt.Color(51, 51, 51)));
			lowerToolbar.add(getLabelTitlePanel(), null);
		}
		return lowerToolbar;
	}

	/**
	 * This method initializes EditButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getEditButton()
	{
		if (EditButton == null)
		{
			EditButton = new JButton();
			EditButton.setText("EDIT");
			EditButton.addActionListener(new java.awt.event.ActionListener() {

				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					System.out.println("Edit Mode initialized"); // TODO
					PaintPanel.setCreateMode(false);
					EditButton.setEnabled(false);
					createButton.setEnabled(true);
					
					enableEdgeField(false);
					enableNodeField(false);
				}
			});
		}
		return EditButton;
	}

	/**
	 * This method initializes createButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getCreateButton()
	{
		if (createButton == null)
		{
			createButton = new JButton();
			createButton.setText("CREATE");
			createButton.setEnabled(false);
			createButton.setSelected(true);
			createButton.addActionListener(new java.awt.event.ActionListener() {

				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					System.out.println("Create Mode initialized"); // TODO
					PaintPanel.setCreateMode(true);
					createButton.setEnabled(false);
					EditButton.setEnabled(true);
					
					enableEdgeField(true);
					enableNodeField(true);
				}
			});
		}
		return createButton;
	}

	/**
	 * This method initializes LabelTitlePanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getLabelTitlePanel()
	{
		if (LabelTitlePanel == null)
		{
			NodelLabelTitleLabel = new JLabel();
			NodelLabelTitleLabel.setText(" Titel:");
			NodelLabelTitleLabel
					.setPreferredSize(new java.awt.Dimension(30,20));
			LabelTitlePanel = new JPanel();
			LabelTitlePanel.setLayout(new FlowLayout());
			LabelTitlePanel.add(NodelLabelTitleLabel, null);
			LabelTitlePanel.add(getNodeLabelTitleTextfield(), null);
		}
		return LabelTitlePanel;
	}

	/**
	 * This method initializes NodeLabelTitleTextfield
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getNodeLabelTitleTextfield()
	{
		if (NodeLabelTitleTextfield == null)
		{
			NodeLabelTitleTextfield = new JTextField();
			NodeLabelTitleTextfield.setPreferredSize(new java.awt.Dimension(140,20));
			NodeLabelTitleTextfield.setText(ExGraph.STANDARD_NODE_LABEL);
			NodeLabelTitleTextfield
					.addKeyListener(new java.awt.event.KeyAdapter() {

						public void keyReleased(java.awt.event.KeyEvent e)
						{
							System.out.println("keyTyped()"); // TODO
							currentNodeLabel = NodeLabelTitleTextfield
									.getText();
							graph.STANDARD_NODE_LABEL = NodeLabelTitleTextfield
							.getText();
							
							if(graph.getActiveNode()!=null) {
								graph.getActiveNode().setLabel(NodeLabelTitleTextfield
									.getText() + " ");
							}
							//graph.update(); // Auto-generated
							// Event stub
							// keyTyped()
						}
					});
		}
		return NodeLabelTitleTextfield;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2()
	{
		if (LowestToolbar == null)
		{
			GridLayout gridLayout3 = new GridLayout();
			gridLayout3.setRows(1);
			gridLayout3.setVgap(5);
			LowestToolbar = new JPanel();
			LowestToolbar
					.setBorder(javax.swing.BorderFactory
							.createTitledBorder(
									javax.swing.BorderFactory.createLineBorder(
											java.awt.Color.gray, 1),
									"Label Info",
									javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
									javax.swing.border.TitledBorder.DEFAULT_POSITION,
									new java.awt.Font("Dialog",
											java.awt.Font.BOLD, 12),
									new java.awt.Color(51, 51, 51)));
			LowestToolbar.setPreferredSize(new java.awt.Dimension(200,91));
			LowestToolbar.setLayout(gridLayout3);
			LowestToolbar.add(getJPanel1(), null);
		}
		return LowestToolbar;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1()
	{
		if (jPanel1 == null)
		{
			jLabel = new JLabel();
			jLabel.setText(" Titel:");
			jLabel.setPreferredSize(new java.awt.Dimension(30,20));
			jPanel1 = new JPanel();
			jPanel1.setLayout(new FlowLayout());
			jPanel1.add(jLabel, null);
			jPanel1.add(getJTextField1(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField1()
	{
		if (jTextField1 == null)
		{
			jTextField1 = new JTextField();
			jTextField1.setText(ExGraph.STANDARD_EDGE_LABEL);
			jTextField1.setPreferredSize(new java.awt.Dimension(140,20));
			jTextField1.setHorizontalAlignment(javax.swing.JTextField.LEADING);
			jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {

				public void keyReleased(java.awt.event.KeyEvent e)
				{
					currentEdgeLabel = jTextField1.getText();
					graph.STANDARD_EDGE_LABEL = currentEdgeLabel;


					if(graph.getActiveEdge()!=null) {
						graph.getActiveEdge().setLabel(jTextField1
							.getText() + " ");
					}
				}
			});
		}
		return jTextField1;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3()
	{
		if (jPanel == null)
		{
			jLabel2 = new JLabel();
			jLabel2.setText(" Display Node Labels:");
			jLabel2.setPreferredSize(new java.awt.Dimension(130,20));
			jPanel = new JPanel();
			jPanel.setLayout(new FlowLayout());
			jPanel.add(jLabel2, null);
			jPanel.add(getAlphaCheckbox(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel32()
	{
		if (jPanel3 == null)
		{
			jLabel3 = new JLabel();
			jLabel3.setText(" Label Size:  ");
			jLabel3.setPreferredSize(new java.awt.Dimension(80,20));
			jPanel3 = new JPanel();
			jPanel3.setLayout(new FlowLayout());
			jPanel3.add(jLabel3, null);
			jPanel3.add(getJSlider1(), null);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jSlider1
	 * 
	 * @return javax.swing.JSlider
	 */
	private JSlider getJSlider1()
	{
		if (jSlider1 == null)
		{
			jSlider1 = new JSlider();
			jSlider1.setMinimum(1);
			jSlider1.setMaximum(40);
			jSlider1.setValue(25);
			jSlider1.setPreferredSize(new java.awt.Dimension(100, 16));
			jSlider1.setPaintLabels(true);
			jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e)
				{
					System.out.println("Font size changed: "
							+ jSlider1.getValue());
					graph.STANDARD_LABEL_FONT_SIZE = jSlider1.getValue();
					graph.update();
				}
			});
		}
		return jSlider1;
	}

	/**
	 * This method initializes AlphaCheckbox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getAlphaCheckbox()
	{
		if (AlphaCheckbox == null)
		{
			AlphaCheckbox = new JCheckBox();
			AlphaCheckbox.setSelected(ExGraph.DRAW_NODE_LABELS);
			AlphaCheckbox.addItemListener(new java.awt.event.ItemListener() {

				public void itemStateChanged(java.awt.event.ItemEvent e)
				{
					System.out.println("itemStateChanged()"); // TODO
					if (AlphaCheckbox.isSelected()) {
						ExGraph.DRAW_NODE_LABELS = true;
					} else {
						ExGraph.DRAW_NODE_LABELS = false;
					}
				}
			});
		}
		return AlphaCheckbox;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4()
	{
		if (jPanel4 == null)
		{
			jLabel4 = new JLabel();
			jLabel4.setText(" Alpha:           ");
			jLabel4.setPreferredSize(new java.awt.Dimension(80,20));
			jPanel4 = new JPanel();
			jPanel4.setLayout(new FlowLayout());
			jPanel4.add(jLabel4, null);
			jPanel4.add(getJSlider2(), null);
		}
		return jPanel4;
	}

	/**
	 * This method initializes jSlider2
	 * 
	 * @return javax.swing.JSlider
	 */
	private JSlider getJSlider2()
	{
		if (jSlider2 == null)
		{
			jSlider2 = new JSlider();
			jSlider2.setMaximum(100);
			jSlider2.setValue(100);
			jSlider2.setPreferredSize(new java.awt.Dimension(100, 16));
			jSlider2.setMinimum(1);
			jSlider2.setPaintLabels(true);
			jSlider2.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e)
				{
					graph.STANDARD_LABEL_ALPHA = (float) jSlider2.getValue()
							/ (float) jSlider2.getMaximum();
					System.out.println("Alpha changed to: "
							+ graph.STANDARD_LABEL_ALPHA); // TODO

				}
			});
		}
		return jSlider2;
	}

	public void run()
	{

		while (Thread.currentThread() == animator)
		{
			// Display the next frame of animation.
			start = System.currentTimeMillis();

			// PaintPane.getGraphics().dispose();
			repaint();
			// graph.update();
			tick_end_time = System.currentTimeMillis();
			tick_duration = tick_end_time - start;
			// System.out.println(tick_duration);
			sleep_duration = MAX_MS_PER_FRAME - tick_duration;

			if (sleep_duration < MIN_SLEEP_TIME)
			{
				sleep_duration = MIN_SLEEP_TIME;
			}
			// fps = 1000 / (sleep_duration + tick_duration);
			// System.out.println(fps);

			// System.out.println(animator.getId());
			// Delay for a while
			try
			{
				Thread.sleep((long) sleep_duration);
			} catch (InterruptedException e)
			{
				break;
			}

		}
	}

	@Override
	public void start()
	{
		animator = new Thread(this);
		animator.start();
	}

	@Override
	public void stop()
	{
		animator = null;

	}

	/**
	 * This method initializes panel
	 * 
	 * @return java.awt.Panel
	 */
	private Panel getPanel()
	{
		if (panel == null)
		{
			panel = new Panel();
			panel.setPreferredSize(new java.awt.Dimension(100, 416));
			panel.setLayout(new BoxLayout(getPanel(), BoxLayout.Y_AXIS));
			panel.add(getUpperToolbar(), null);
			panel.add(getMiddleToolbar(), null);
			panel.add(getLowerToolbar(), null);
			panel.add(getJPanel2(), null);
			panel.add(getJPanel22(), null);
		}
		return panel;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel22()
	{
		if (jPanel2 == null)
		{
			jPanel2 = new JPanel();
			jPanel2.setLayout(new FlowLayout());
			jPanel2.setPreferredSize(new java.awt.Dimension(10, 10000));
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel5
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel5()
	{
		if (jPanel5 == null)
		{
			jLabel1 = new JLabel();
			jLabel1.setPreferredSize(new java.awt.Dimension(80,20));
			jLabel1.setText(" Curvature:   ");
			jPanel5 = new JPanel();
			jPanel5.setLayout(new FlowLayout());
			jPanel5.add(jLabel1, null);
			jPanel5.add(getJSlider(), null);
		}
		return jPanel5;
	}

	/**
	 * This method initializes jSlider
	 * 
	 * @return javax.swing.JSlider
	 */
	private JSlider getJSlider()
	{
		if (jSlider == null)
		{
			jSlider = new JSlider();
			jSlider.setPreferredSize(new Dimension(100, 16));
			jSlider.setPaintLabels(true);
			jSlider.setValue(graph.STANDARD_LABEL_ARC);
			jSlider.setMinimum(-200);
			jSlider.setMaximum(200);
			jSlider.addChangeListener(new javax.swing.event.ChangeListener() {

				public void stateChanged(javax.swing.event.ChangeEvent e)
				{
					// System.out.println("Curvature set"); // TODO
					// Auto-generated Event stub stateChanged()
					graph.STANDARD_LABEL_ARC = jSlider.getValue();// -
					ExGraph.DRAW_PERFORMANCE_MODE = true; // jSlider.getMaximum()/2;
					graph.update();
					// ExGraph.DRAW_PERFORMANCE_MODE = false;
				}
			});

			jSlider.addMouseListener(new MouseListener() {

				public void mouseReleased(MouseEvent arg0)
				{

					ExGraph.DRAW_PERFORMANCE_MODE = false;
					graph.update();
				}

				public void mouseClicked(MouseEvent arg0)
				{
					// TODO Auto-generated method stub

				}

				public void mousePressed(MouseEvent arg0)
				{
					// TODO Auto-generated method stub

				}

				public void mouseEntered(MouseEvent arg0)
				{
					// TODO Auto-generated method stub

				}

				public void mouseExited(MouseEvent arg0)
				{
					// TODO Auto-generated method stub

				}

			});
		}
		return jSlider;
	}

	/**
	 * This method initializes jPanel6
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel6()
	{
		if (jPanel6 == null)
		{
			jLabel5 = new JLabel();
			jLabel5.setPreferredSize(new java.awt.Dimension(130,20));
			jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			jLabel5.setText(" Standard Edges:");
			jPanel6 = new JPanel();
			jPanel6.setLayout(new FlowLayout());
			jPanel6.add(jLabel5, null);
			jPanel6.add(getJCheckBox(), null);
		}
		return jPanel6;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox()
	{
		if (jCheckBox == null)
		{
			jCheckBox = new JCheckBox("", ExGraph.DRAW_STANDARD_EDGES);
			jCheckBox.addItemListener(new java.awt.event.ItemListener() {

				public void itemStateChanged(java.awt.event.ItemEvent e)
				{
					System.out.println("Standard Mode?"); // TODO
					// Auto-generated
					// Event stub
					// itemStateChanged()
					if (jCheckBox.isSelected())
					{
						graph.DRAW_STANDARD_EDGES = true;
					} else
					{
						graph.DRAW_STANDARD_EDGES = false;
					}

				}
			});
		}
		return jCheckBox;
	}

	/**
	 * This method initializes upPaintPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getUpPaintPanel()
	{
		if (upPaintPanel == null)
		{
			upPaintPanel = new JPanel();
			upPaintPanel.setLayout(new BoxLayout(getUpPaintPanel(),
					BoxLayout.Y_AXIS));
			upPaintPanel.add(getLeftPanel(), null);
		}
		return upPaintPanel;
	}
	
	public void enableEdgeField(boolean en) {
		jTextField1.setEnabled(en);
	}
	
	public void enableNodeField(boolean en) {
		NodeLabelTitleTextfield.setEnabled(en);
	}
	
	public void setNodeText(String text) {
		NodeLabelTitleTextfield.setText(text);
	}
	
	public void setEdgeText(String text) {
		jTextField1.setText(text);
	}

	
	public String getCurrentEdgeLabel()
	{
		currentEdgeLabel = jTextField1.getText();
		return currentEdgeLabel;
	}

	
	public void setCurrentEdgeLabel(String currentEdgeLabel)
	{
		this.currentEdgeLabel = currentEdgeLabel;
	}

	
	public String getCurrentNodeLabel()
	{
		currentNodeLabel = NodeLabelTitleTextfield.getText();
		return currentNodeLabel;
	}

	
	public void setCurrentNodeLabel(String currentNodeLabel)
	{
		this.currentNodeLabel = currentNodeLabel;
	}
	


} // @jve:decl-index=0:visual-constraint="10,10"
