package exlabel.gui;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JApplet;
import javax.swing.JPanel;

import exlabel.structure.ExEdge;
import exlabel.structure.ExGraph;
import exlabel.structure.ExNode;

public class ExPaintPanel extends JPanel implements MouseListener,
		MouseMotionListener
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -3931066662014001816L;

	private ExGraph graph;

	private int hitNode;

	private ExNode EdithitNode;

	private boolean pressedEmptySpace;

	private boolean pressedNode;

	private boolean pressedLabel;

	private boolean createMode = true;
	
	private boolean editpressedNode = false;
	
	private boolean editpressedEmptySpace = false;
	
	private ExGui exgui;
	

	

	public ExPaintPanel(ExGraph graph, ExGui exgui)
	{
		super();
		addMouseListener(this);
		addMouseMotionListener(this);
		this.graph = graph;
		this.hitNode = -1;
		
		this.exgui = exgui;

		this.EdithitNode = new ExNode(0, 0, 0, ExGraph.STANDARD_NODE_RADIUS,
				ExGraph.STANDARD_NODE_MASS, exgui.currentNodeLabel, graph.getRender());
		this.pressedEmptySpace = false;
		this.pressedNode = false;
		this.pressedLabel = false;
	}

	protected void paintComponent(Graphics g)
	{

		Graphics2D g2d = (Graphics2D) g;
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);
		g2d.setRenderingHint(RenderingHints.KEY_RENDERING,
				(RenderingHints.VALUE_RENDER_SPEED));
		g2d.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL,
				RenderingHints.VALUE_STROKE_PURE);

		graph.draw(g2d);

	}

	public void mouseDragged(MouseEvent arg0)
	{
		
		mouseMovedCheckup(arg0);

		if (createMode)
		{
			mouseDraggedCreateMode(arg0);
		}

		else {
			ExGraph.DRAW_PERFORMANCE_MODE = true;
			mouseDraggedEditMode(arg0);
		}
	}

	public void mouseMoved(MouseEvent arg0)
	{

		mouseMovedCheckup(arg0);
	}

	public void mouseClicked(MouseEvent arg0)
	{

		if (createMode)
		{

		} else
		{

			mouseClickedEditMode(arg0);

		}

	}

	public void mousePressed(MouseEvent arg0)
	{

		if (createMode)
		{
			mousePressedCreateMode(arg0);
		} else
			mousePressedEditMode(arg0);

	}

	public void mouseReleased(MouseEvent arg0)
	{
		ExGraph.DRAW_PERFORMANCE_MODE = false;
		graph.update();
		if (createMode)
		{
			mouseReleasedCreateMode(arg0);
		} else
			mouseReleasedEditMode(arg0);

	}

	public void mouseEntered(MouseEvent arg0)
	{
		System.out.println("entered");

	}

	public void mouseExited(MouseEvent arg0)
	{
		System.out.println("left");

	}

	public void mouseReleasedEditMode(MouseEvent arg0)
	{
		editpressedEmptySpace = false;
		editpressedNode = false;

	}

public void mousePressedEditMode(MouseEvent arg0)
	{
		
	ExNode checkNode = graph.hitNode(arg0.getX(), arg0.getY());
	
	System.out.println("button pressed at " + arg0.getX() + " - "
			+ arg0.getY());
	if (checkNode != null)
	{
		System.out.println("You hit a Node");
		//hitNode .setPosition(checkNode.getXpos(), checkNode.getYpos(), 0);
		editpressedEmptySpace = false;
		editpressedNode = true;
		EdithitNode = checkNode;

	} else
	{
		editpressedEmptySpace = true;
		editpressedNode = false;

	}

	}	public void mouseDraggedEditMode(MouseEvent arg0)
	{
		
		if (editpressedEmptySpace)
		{
			System.out.println("eventually draw grid");
		}

		if (editpressedNode)
		{

			System.out.println("eventually draw grid");
			EdithitNode.setPosition(arg0.getX(), arg0.getY(), 1);
			graph.update();

		}

	}

	public void mouseReleasedCreateMode(MouseEvent arg0)
	{

		// VORHER IM LEEREN RAUM GEDRCKT

		int releaseNode = graph.hitNodeInt(arg0.getX(), arg0.getY());
		//ExNode releaseNode = graph.hitNode(arg0.getX(), arg0.getY());
		if (pressedEmptySpace)
		{

			// UND EINEN KNOTEN GETROFFEN, MACH NIX
			if (releaseNode != -1)
			{
				System.out.println("You hit a Node, you're out");
				graph.disableTempNodeDrawing();

				// SONST FGE EINEN NEUEN KNOTEN EIN
			} else
			{

				System.out.println("You made a Node");
				ExNode newNode = new ExNode(arg0.getX(), arg0.getY(), 0,
						ExGraph.STANDARD_NODE_RADIUS,
						ExGraph.STANDARD_NODE_MASS, exgui.getCurrentNodeLabel(), graph.getRender());
				graph.addNode(newNode);
			}

			// VORHER EINEN KNOTEN GETROFFEN HAST
		} else if (pressedNode)
		{

			// UND DANN EINEN KNOTEN
			if (releaseNode != -1)
			{

				// DER DER SELBE WIE VORHER WAR
				// TODO: USE NodeHitNode()!!!
				if (graph.getNodeById(releaseNode).getXpos() == graph.getNodeById(hitNode).getXpos()
						&& graph.getNodeById(releaseNode).getYpos() == graph.getNodeById(hitNode).getYpos())
				{
					System.out
							.println("You idiot, you hit the same Node again");
					// DER NICHT DER SELBE WIE VORHER WAR
				} else
				{
					ExNode StartNode = graph.hitNode(graph.getNodeById(hitNode).getXpos(), graph.getNodeById(hitNode).getYpos());
					ExNode EndNode = graph.hitNode(graph.getNodeById(releaseNode).getXpos(), graph.getNodeById(releaseNode).getYpos());
					ExEdge newedge = new ExEdge(StartNode, EndNode,
							exgui.getCurrentEdgeLabel(), graph.getRender());
					graph.addEdge(newedge);
					System.out.println("You Made an edge");

				}
			} else
			{

				ExNode endnode = new ExNode(arg0.getX(), arg0.getY(), 0,
						ExGraph.STANDARD_NODE_RADIUS,
						ExGraph.STANDARD_NODE_MASS, exgui.getCurrentNodeLabel(), graph.getRender());
				graph.addNode(endnode);
				ExNode StartNode = graph.hitNode(graph.getNodeById(hitNode).getXpos(), graph.getNodeById(hitNode).getYpos());
				ExEdge newedge = new ExEdge(StartNode, endnode,
						exgui.getCurrentEdgeLabel(), graph.getRender());
				graph.addEdge(newedge);
			}

		} else if (pressedLabel)
		{

			// TODO: do something

		}

		graph.disableTempEdgeDrawing();
		graph.disableTempNodeDrawing();
		pressedEmptySpace = false;
		pressedLabel = false;
		pressedNode = false;

	}

	public void mousePressedCreateMode(MouseEvent arg0)
	{
		hitNode = graph.hitNodeInt(arg0.getX(), arg0.getY());
		System.out.println("button pressed at " + arg0.getX() + " - "
				+ arg0.getY());
		if (hitNode != -1)
		{
			System.out.println("You hit a Node");
			//graph.getNodeById(hitNode).setPosition(checkNode.getXpos(), checkNode.getYpos(), 0);
			pressedEmptySpace = false;
			pressedNode = true;
			pressedLabel = false;
			graph.setInsertDraggingTempEdge(graph.getNodeById(hitNode), graph.getNodeById(hitNode),
					ExGraph.STANDARD_EDGE_LABEL);
			graph.enableTempEdgeDrawing();
		} else
		{
			pressedEmptySpace = true;
			pressedNode = false;
			pressedLabel = false;
			graph.setInsertDraggingTempNode(arg0.getX(), arg0.getY(), 0,
					ExGraph.STANDARD_NODE_RADIUS, ExGraph.STANDARD_NODE_MASS);
			graph.enableTempNodeDrawing();
		}
	}

	public void mouseDraggedCreateMode(MouseEvent arg0)
	{

		if (pressedEmptySpace)
		{
			graph.setInsertDraggingTempNode(arg0.getX(), arg0.getY(), 0,
					ExGraph.STANDARD_NODE_RADIUS, ExGraph.STANDARD_NODE_MASS);
		}

		if (pressedNode)
		{

			ExNode recentNode = new ExNode(arg0.getX(), arg0.getY(), 0,
					ExGraph.STANDARD_NODE_RADIUS, ExGraph.STANDARD_NODE_MASS, exgui.currentNodeLabel,
					graph.getRender());
			graph.setInsertDraggingTempEdge(graph.getNodeById(hitNode), recentNode,
					ExGraph.STANDARD_EDGE_LABEL);


		}

	}

	public void mouseClickedEditMode(MouseEvent arg0)
	{
		

		ExNode mouseNode = graph.hitNode(arg0.getX(), arg0.getY());
		ExEdge tempEdge = graph.hitEdge(arg0.getX(), arg0.getY());
		if (mouseNode != null)
		{
			graph.setActiveNode(mouseNode);
			System.out.println("clicking a node.");
			exgui.enableNodeField(true);
			exgui.setNodeText(mouseNode.getLabel());
		} else
		{
			graph.setActiveNode(null);
			
			exgui.enableNodeField(false);
		}

		if (tempEdge != null && mouseNode == null)
		{
			graph.setActiveEdge(tempEdge);
			System.out.println("clicking an edge.");
			exgui.enableEdgeField(true);
			exgui.setEdgeText(tempEdge.getLabel());
		}

		else
		{
			graph.setActiveEdge(null);
			
			exgui.enableEdgeField(false);
		}

	}

	public void mouseMovedCheckup(MouseEvent arg0)
	{
		ExNode mouseNode = graph.hitNode(arg0.getX(), arg0.getY());
		ExEdge tempEdge = graph.hitEdge(arg0.getX(), arg0.getY());
		if (mouseNode != null)
		{
			graph.setMouseOverTempNode(mouseNode);
			System.out.println("passing a node.");
		} else
		{
			graph.setMouseOverTempNode(null);
		}

		if (tempEdge != null && mouseNode == null)
		{
			graph.setMouseOverTempEdge(tempEdge);
			System.out.println("passing an edge.");
		}

		else
		{
			graph.setMouseOverTempEdge(null);
		}
	}

	public boolean isCreateMode()
	{
		return createMode;
	}

	public void setCreateMode(boolean createMode)
	{
		this.createMode = createMode;
	}

}
