package exlabel.structure;

import java.awt.Graphics2D;

import exlabel.util.ExRenderer;

public class ExNode implements IExNode {

	private int id;
	
	private int xpos, ypos, zpos;

	private int radius;

	private float mass;
	
	private String label;

	private ExRenderer render;
	
	boolean temp = false;
	
	boolean mouseover = false;
	
	boolean active = false;

	public ExNode() {

		this.xpos = 0;
		this.ypos = 0;
		this.zpos = 0;
		this.radius = 0;
		this.mass = 0;
		
		this.label = ExGraph.STANDARD_LABEL_FONT;

		this.render = null;
	}

	public ExNode(int xpos, int ypos, int zpos, int radius, float mass, String label,
			ExRenderer render) {

		this.xpos = xpos;
		this.ypos = ypos;
		this.zpos = zpos;
		this.radius = radius;
		this.mass = mass;
		this.render = render;
		
		this.label = label;

	}

	public void draw(Graphics2D g2d, int mode) {

		if (mode > 0) {
			update();
		}
		
		render.drawNode(this, g2d, mode);

	}


	public void update() {
		// TODO implement
		// this.xpos += 1;
		// this.ypos += 1;

	}

	// GETTERS AND SETTERS

	public boolean NodeHitNode(ExNode nodeA) {

		// TODO: implement

		return false;
	}

	public ExNode duplicate() {

		ExNode returnNode = new ExNode(this.xpos, this.ypos, this.zpos,
				this.radius, this.mass, this.label, this.render);
		return returnNode;

	}
	

	
	public boolean equals(Object arg0) {
		
		ExNode inNode = (ExNode) arg0;
		if (this.xpos == inNode.getXpos() && this.ypos == inNode.getYpos() && this.zpos == inNode.getZpos()) {
			return true;
		} else {
			return false;
		}
	}

	public float getMass() {
		return mass;
	}

	public void setMass(float mass) {
		this.mass = mass;
	}

	public int getRadius() {
		return radius;
	}

	public void setRadius(int radius) {
		this.radius = radius;
	}

	public void setPosition(int xpos, int ypos, int zpos) {
		this.xpos = xpos;
		this.ypos = ypos;
		this.zpos = zpos;
	}

	public int getXpos() {
		return xpos;
	}

	public int getYpos() {
		return ypos;
	}

	public int getZpos() {
		return zpos;
	}

	
	public int getId()
	{
		return id;
	}

	
	public void setId(int id)
	{
		this.id = id;
	}

	
	public String getLabel()
	{
		return label;
	}

	
	public void setLabel(String label)
	{
		if(label != null) {
			label.trim();
			this.label = label;
			
		}else {
			this.label = " ";
		}
	}

}
